// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'starter.controllers','ngCordova'])

.run(function($ionicPlatform,$cordovaStatusbar) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);

    }
      if (window.StatusBar) {
          // org.apache.cordova.statusbar required
          StatusBar.styleDefault();
      }
      $cordovaStatusbar.show();

  });
})

.config(function($stateProvider, $urlRouterProvider,$ionicConfigProvider) {

    $ionicConfigProvider.views.transition('none');
  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js

    $stateProvider

        .state('startGame', {
            url: "/startGame",
            templateUrl: "templates/startGame.html",
            controller : 'GameStartCtrl'
        })

        .state('selectCategory', {
            url: "/selectCategory",
            templateUrl: "templates/category_landscape.html",
            controller : 'CategoryCtrl'
        })

        .state('rotateScreen', {
            url: "/rotateScreen",
            templateUrl: "templates/rotate_screen.html",
            controller : 'RotateCtrl'
        })

        .state('gameScreen', {
            url: "/gameScreen",
            templateUrl: "templates/game.html",
            controller : 'GameCtrl'
        })

        .state('resultScreen', {
            url: "/resultScreen",
            templateUrl: "templates/result_screen.html",
            controller : 'ResultCtrl'
        })

        .state('howtoplay', {
            url: "/howtoplay",
            templateUrl: "templates/how_to_play.html",
            controller : 'HowToPlayCtrl'
        })

        .state('settings', {
            url: "/settings",
            templateUrl: "templates/settings.html",
            controller : 'SettingCtrl'
        })

        .state('preGame', {
            url: "/preGame",
            templateUrl: "templates/preGame.html",
            controller : 'preGameCtrl'
        })

        .state('about', {
            url: "/about",
            templateUrl: "templates/about.html",
            controller : 'AboutCtrl'
        })

    $urlRouterProvider.otherwise('/startGame');
});
