angular.module('starter.controllers', ['ionic', 'ngCordova'])


.controller('GameStartCtrl', function($state,$scope,$rootScope,$ionicPopup,$cordovaNativeAudio,$ionicPlatform,$cordovaGoogleAnalytics) {

        $scope.$on('$ionicView.beforeEnter', function(){
            $rootScope.gameType='Bollywood';
            console.log("cp4");
            $scope.settingModel = JSON.parse(window.localStorage['userSettings'] || '{}');
            if(JSON.stringify($scope.settingModel) === "{}") {
                $scope.settingModel = {
                    sound: true,
                    vibration: true
                };
                $rootScope.enableSound = $scope.settingModel.sound;
                $rootScope.enableVibration = $scope.settingModel.vibration;
            }


        });



    $ionicPlatform.registerBackButtonAction(function () {
        console.log("i m here at back button to exit the app.");
        console.log($state.current.name);

        if($state.current.name == "startGame"){
            $scope.showConfirm();
        }



    }, 100);



    $scope.showConfirm = function(){
        console.log("in show confirm dialog");

        var confirmPopup = $ionicPopup.confirm({
            title: 'Exit Game',
            template: 'Are you sure you want to exit this Game ?'
        });

        confirmPopup.then(function(res) {
            if(res) {
                console.log('exiting the app');
                $cordovaGoogleAnalytics.trackEvent("GameExitWithBack","YES",$rootScope.gameMode,$rootScope.gameScore);
//                navigator.app.exitApp();
                ionic.Platform.exitApp()

            } else {
                console.log('You are not sure');
                $cordovaGoogleAnalytics.trackEvent("GameExitWithBack","NO",$rootScope.gameMode,$rootScope.gameScore);
            }
        });
    };





    $ionicPlatform.ready(function() {
        if($rootScope.gameType == undefined){
            $rootScope.gameType='Bollywood';
        }

        if($rootScope.gameScore== undefined){
            $rootScope.gameScore=0;
        }


        console.log("everything is ready ");
        $cordovaGoogleAnalytics.startTrackerWithId('UA-75583108-1');
        $cordovaGoogleAnalytics.trackView('Gamestart Screen');

        // then override any default you want
        window.plugins.nativepagetransitions.globalOptions.duration = 250;
        window.plugins.nativepagetransitions.globalOptions.iosdelay = 200;
        window.plugins.nativepagetransitions.globalOptions.androiddelay = 200;
        window.plugins.nativepagetransitions.globalOptions.winphonedelay = 200;
        window.plugins.nativepagetransitions.globalOptions.slowdownfactor = 3;
        // these are used for slide left/right only currently
        window.plugins.nativepagetransitions.globalOptions.fixedPixelsTop = 0;
        window.plugins.nativepagetransitions.globalOptions.fixedPixelsBottom = 0;
    });



    



    $scope.setGameType= function(game_type){

            angular.element( document.querySelector( '#hollywood_bg' ) ).removeClass('game_mode_button_select');
            angular.element( document.querySelector( '#hollywood_bg' ) ).removeClass('game_mode_button_unselect');
            angular.element( document.querySelector( '#bollywood_bg' ) ).removeClass('game_mode_button_select');
            angular.element( document.querySelector( '#bollywood_bg' ) ).removeClass('game_mode_button_unselect');

            if(game_type=="Bollywood"){

                $rootScope.gameType='Bollywood';
                angular.element( document.querySelector( '#hollywood_bg' ) ).addClass('game_mode_button_unselect button');
                angular.element( document.querySelector( '#bollywood_bg' ) ).addClass('game_mode_button_select button');
            }else if(game_type=="Hollywood"){

                $rootScope.gameType='Hollywood';
                angular.element( document.querySelector( '#hollywood_bg' ) ).addClass('game_mode_button_select button');
                angular.element( document.querySelector( '#bollywood_bg' ) ).addClass('game_mode_button_unselect button');
            }
        }

        $scope.gotoScreen2 = function(){
            //$state.go('selectCategory');
            $state.go('selectCategory');
            window.plugins.nativepagetransitions.slide(
                {"direction":"right"},
                function (msg) {console.log("success: " + msg)}, // called when the animation has finished
                function (msg) {alert("error: " + msg)} // called in case you pass in weird values
            );
        }

        $scope.gotoHowToPlay = function(){
            $state.go('howtoplay');
            window.plugins.nativepagetransitions.slide(
                {"direction":"right"},
                function (msg) {console.log("success: " + msg)}, // called when the animation has finished
                function (msg) {alert("error: " + msg)} // called in case you pass in weird values
            );

        }

        $scope.gotoSettings = function(){
            $state.go('settings');
            window.plugins.nativepagetransitions.slide(
                {"direction":"right"},
                function (msg) {console.log("success: " + msg)}, // called when the animation has finished
                function (msg) {alert("error: " + msg)} // called in case you pass in weird values
            );
        }

        $scope.gotoAbout = function(){
            $state.go('about');
            window.plugins.nativepagetransitions.slide(
                {"direction":"right"},
                function (msg) {console.log("success: " + msg)}, // called when the animation has finished
                function (msg) {alert("error: " + msg)} // called in case you pass in weird values
            );
        }
    })

.controller('HowToPlayCtrl', function($scope,$state,$rootScope,$ionicSlideBoxDelegate,$ionicGesture,$ionicPlatform,$cordovaGoogleAnalytics) {

    $scope.$on('$ionicView.beforeEnter', function(){
        //$ionicSlideBoxDelegate.slide(0);
        $scope.slide_counter=1;
    });

    $scope.gesture = {
        used: ''
    };

    var element = angular.element(document.querySelector('#content'));

    $ionicGesture.on('tap', function(e){
        $scope.$apply(function() {
            $scope.gesture.used = 'Tap';
        })
    }, element);

    $scope.onGesture = function(gesture) {

        $scope.gesture.used = gesture;
        switch (gesture){
            case "Swipe Left":
                $scope.decreaseCard();
                break;

            case "Swipe Right":
                $scope.increaseCard();
                break;
        }
    }
    
    $scope.increaseCard = function(){

        if($scope.slide_counter>=9){

            var quote_card=angular.element(document.getElementById("display_image"));
            quote_card.onclick=$scope.SkipSlideShow();

        }else{

            $scope.slide_counter=$scope.slide_counter+1;
            $scope.curr_slide_setting="increase";
            var dismissAnimationClass ='bounceOutRight';
            console.log("bounceOutRight class css");
            dismissAnimationClass += " fullscreen-image animated ";
            var quote_card=angular.element(document.getElementById("display_image"));
            quote_card.onclick="#";
            quote_card.removeAttr("class");
            quote_card.addClass(dismissAnimationClass);
            quote_card.one('webkitAnimationEnd mozAnimationEnd MSAnimationEnd oanimationend animationend', showNewCard);
        }
    }



    $scope.decreaseCard = function () {
        if($scope.slide_counter<=1){

        }else{
            $scope.slide_counter=$scope.slide_counter-1;
            var dismissAnimationClass ='bounceOutLeft';
            $scope.curr_slide_setting="decrease";
            console.log("bounceOutRight class css");
            dismissAnimationClass += " fullscreen-image animated ";
            var quote_card=angular.element(document.getElementById("display_image"));
            quote_card.removeAttr("class");
            quote_card.addClass(dismissAnimationClass);
            quote_card.one('webkitAnimationEnd mozAnimationEnd MSAnimationEnd oanimationend animationend', showNewCard2);
        }
    }

    function showNewCard2(){

        var entryAnimationClass ="bounceInRight";
        console.log("bounceInLeft class css");
        entryAnimationClass += " fullscreen-image animated ";
        var quote_card=angular.element(document.getElementById("display_image"));
        var img_src="img/how_to_play/screen_"+$scope.slide_counter+".png";
        quote_card.attr('src', img_src);
        quote_card.removeAttr("class");
        quote_card.addClass(entryAnimationClass);
    }

    function showNewCard(){

        var entryAnimationClass ="bounceInLeft";

        entryAnimationClass += " fullscreen-image animated ";
        var quote_card=angular.element(document.getElementById("display_image"));
        var img_src="img/how_to_play/screen_"+$scope.slide_counter+".png";
        quote_card.attr('src', img_src);
        quote_card.removeAttr("class");
        quote_card.addClass(entryAnimationClass);
    }

    $ionicPlatform.ready(function() {
        console.log("everything is ready ");
        $cordovaGoogleAnalytics.startTrackerWithId('UA-75583108-1');
        $cordovaGoogleAnalytics.trackView('Howtoplay screen');
        console.log("cordova analytics");
        var quote_card=angular.element(document.getElementById("display_image"));
        var img_src="img/how_to_play/screen_1.png";
        quote_card.attr('src', img_src);
    });

    $scope.slideHasChanged = function($index){
        if($index === 8){
            angular.element(document.querySelector('#skip_btn_how_to_play')).addClass('skip_button_hide');
        }else{
            angular.element(document.querySelector('#skip_btn_how_to_play')).removeClass('skip_button_hide');
        }
    };

    $scope.SkipSlideShow= function(){
            $state.go('startGame');
        window.plugins.nativepagetransitions.slide(
            {"direction":"left"},
            function (msg) {console.log("success: " + msg)}, // called when the animation has finished
            function (msg) {alert("error: " + msg)} // called in case you pass in weird values
        );


        }

    $scope.startGameFromHowtoPlay = function(){
        $rootScope.gameScore=0;
        $state.go('selectCategory');
    }

    })

.controller('AboutCtrl', function($scope,$ionicHistory,$state,$cordovaGoogleAnalytics,$ionicPlatform) {

    $scope.$on('$ionicView.beforeEnter', function(){
        $cordovaGoogleAnalytics.startTrackerWithId('UA-75583108-1');

    });

    $ionicPlatform.ready(function() {
        console.log("everything is ready ");
        $cordovaGoogleAnalytics.startTrackerWithId('UA-75583108-1');
        $cordovaGoogleAnalytics.trackView('About screen');
        console.log("cordova analytics");
    });


    $scope.goToHomeScreen= function(){
            //$ionicHistory.goBack();
            $state.go('startGame');
        window.plugins.nativepagetransitions.slide(
            {"direction":"left"},
            function (msg) {console.log("success: " + msg)}, // called when the animation has finished
            function (msg) {alert("error: " + msg)} // called in case you pass in weird values
        );
        }

})

.controller('preGameCtrl', function($scope,$ionicHistory,$state,$cordovaGoogleAnalytics,$ionicPlatform,$timeout) {

        $scope.$on('$ionicView.beforeEnter', function(){
            $cordovaGoogleAnalytics.startTrackerWithId('UA-75583108-1');
            $scope.counter=5;
            var myEl1 = angular.element(document.querySelector('#pre_counter'));
            myEl1.html($scope.counter);
            var mytimeout = $timeout($scope.onTimeout,1000);
        });


        $ionicPlatform.ready(function() {
            $cordovaGoogleAnalytics.startTrackerWithId('UA-75583108-1');
            $cordovaGoogleAnalytics.trackView('preGame screen');
            $scope.counter=5;
            $scope.onTimeout = function(){
                console.log("counter is "+$scope.counter);
                if($scope.counter>1) {
                    $scope.counter--;
                    var myEl1 = angular.element(document.querySelector('#pre_counter'));
                    myEl1.html($scope.counter);
                    mytimeout = $timeout($scope.onTimeout, 1000);
                }else{
                    $scope.stop();
                    $scope.counter=5;
                }
            }



            $scope.stop = function(){
                $timeout.cancel(mytimeout);
                $state.go('gameScreen');
            }

        });




        $scope.goToHomeScreen= function(){
            $timeout.cancel(mytimeout);
            $state.go('selectCategory');
            window.plugins.nativepagetransitions.slide(
                {"direction":"left"},
                function (msg) {console.log("success: " + msg)}, // called when the animation has finished
                function (msg) {alert("error: " + msg)} // called in case you pass in weird values
            );
        }

    })

.controller('SettingCtrl', function($scope,$ionicHistory,$state,$rootScope,$ionicPopup,$cordovaNativeAudio,$cordovaGoogleAnalytics,$ionicPlatform) {

    $scope.$on('$ionicView.beforeEnter', function(){
        $scope.settingModel = JSON.parse(window.localStorage['userSettings'] || '{}');
        if(JSON.stringify($scope.settingModel) === "{}"){
            $scope.settingModel = {
                sound : true,
                vibration : true
            };
        }
    });


    $ionicPlatform.ready(function() {
        console.log("everything is ready ");
        $cordovaGoogleAnalytics.startTrackerWithId('UA-75583108-1');
        $cordovaGoogleAnalytics.trackView('Setting screen');
        console.log("cordova analytics");
    });



    $scope.goToHomeScreen= function(){
        //$ionicHistory.goBack();
        $state.go('startGame');
        window.plugins.nativepagetransitions.slide(
            {"direction":"left"},
            function (msg) {console.log("success: " + msg)}, // called when the animation has finished
            function (msg) {alert("error: " + msg)} // called in case you pass in weird values
        );
    }

    $scope.saveSettings = function(){
        $rootScope.enableSound=$scope.settingModel.sound;
        $rootScope.enableVibration=$scope.settingModel.vibration;
        window.localStorage['userSettings'] = JSON.stringify($scope.settingModel);
        $scope.showAlert();


        if($rootScope.enableSound){
            $cordovaNativeAudio.loop('music2');
        }else{
            $cordovaNativeAudio.stop('music2');
        }
    };

    $scope.showAlert = function() {
        var alertPopup = $ionicPopup.alert({
            title: 'Settings',
            template: 'Your  Game settings have been successfully updated.'
        });
    };


    })

.controller('CategoryCtrl', function($scope,$rootScope,$state,$cordovaDeviceMotion,$http,$cordovaGoogleAnalytics,$ionicPlatform) {

    $scope.goToHomeScreen= function(){
        //$ionicHistory.goBack();
        $state.go('startGame');
        window.plugins.nativepagetransitions.slide(
            {"direction":"left"},
            function (msg) {console.log("success: " + msg)}, // called when the animation has finished
            function (msg) {alert("error: " + msg)} // called in case you pass in weird values
        );


    }

    $scope.$on('$ionicView.beforeEnter', function(){
        console.log("hi i am here guys  CP!");
        screen.lockOrientation('landscape-primary');
        setGameData();
        window.plugins.insomnia.allowSleepAgain();
        $scope.gameType=$rootScope.gameType;
    });


    $ionicPlatform.ready(function() {
        console.log("everything is ready ");
        $cordovaGoogleAnalytics.startTrackerWithId('UA-75583108-1');
        $cordovaGoogleAnalytics.trackView('Category screen');
        console.log("cordova analytics");
    });




    $scope.easyMode=120;
    $scope.hardMode=60;
    $rootScope.gameMode=$scope.easyMode;

    function setGameData(){


        if($rootScope.gameType == "Bollywood"){

            $http
                .get('data/bollywood_data.json')
                .success(function (response) {
                    var result = response;
                    $scope.actorArray = result.actor;
                    $scope.directorArray = result.director;
                    $scope.televisionArray = result.television;
                    $scope.moviesArray = result.movies;
                    $rootScope.gameArray=$scope.moviesArray;
                });

        }else if($rootScope.gameType=='Hollywood'){

            $http
                .get('data/hollywood_data.json')
                .success(function (response) {
                    var result = response;
                    $scope.actorArray = result.actor;
                    $scope.directorArray = result.director;
                    $scope.televisionArray = result.television;
                    $scope.moviesArray = result.movies;
                    $rootScope.gameArray=$scope.moviesArray;
                });
        }




    }

    function unsetAllCategories(){
        if($scope.gameType=='Bollywood'){
            angular.element(document.querySelector('#movies_bg')).attr('src', 'img/project_images/movies.png');
            angular.element(document.querySelector('#actor_bg')).attr('src', 'img/project_images/actor_bolly.png');
            angular.element(document.querySelector('#director_bg')).attr('src', 'img/project_images/director.png');
            angular.element(document.querySelector('#television_bg')).attr('src', 'img/project_images/tv_bolly.png');
        }else {
            angular.element(document.querySelector('#movies_bg')).attr('src', 'img/project_images/movies.png');
            angular.element(document.querySelector('#actor_bg')).attr('src', 'img/project_images/actor.png');
            angular.element(document.querySelector('#director_bg')).attr('src', 'img/project_images/director.png');
            angular.element(document.querySelector('#television_bg')).attr('src', 'img/project_images/tv.png');
        }
    }

    $scope.setGameType= function(game_type){
        unsetAllCategories();

        switch (game_type){

            case "movies":
                $rootScope.gameArray=$scope.moviesArray;

                angular.element( document.querySelector( '#movies_bg' )).attr('src','img/project_images/movies_sel.png');
                break;

            case "actor":
                $rootScope.gameArray=$scope.actorArray;
                if($scope.gameType=='Bollywood') {
                    angular.element(document.querySelector('#actor_bg')).attr('src', 'img/project_images/actor_bolly_select.png');
                }else{
                    angular.element(document.querySelector('#actor_bg')).attr('src', 'img/project_images/actor_sel.png');
                }
                break;

            case "director":
                $rootScope.gameArray=$scope.directorArray;
                angular.element( document.querySelector( '#director_bg' )).attr('src','img/project_images/director_sel.png');
                break;

            case "television":
                $rootScope.gameArray=$scope.televisionArray;
                if($scope.gameType=='Bollywood') {
                    angular.element(document.querySelector('#television_bg')).attr('src', 'img/project_images/tv_bolly_select.png');
                }else {
                    angular.element(document.querySelector('#television_bg')).attr('src', 'img/project_images/tv_sel.png');
                }
                break;
        }
    }

    $scope.setGameMode = function(game_mode){

        console.log("game mode "+game_mode);
        switch (game_mode){

            case "easy":
                game_mode="easy";
                $rootScope.gameMode=$scope.easyMode;
                angular.element( document.querySelector( '#easy_bg' ) ).removeClass('category_button category_button_unsel');
                angular.element( document.querySelector( '#hard_bg' ) ).removeClass('category_button_unsel category_button ');
                angular.element( document.querySelector( '#easy_bg' ) ).addClass('category_button');
                angular.element( document.querySelector( '#hard_bg' ) ).addClass('category_button_unsel');

                break;


            case "hard":
                game_mode="hard";
                $rootScope.gameMode=$scope.hardMode;
                angular.element( document.querySelector( '#easy_bg' ) ).removeClass('category_button category_button_unsel');
                angular.element( document.querySelector( '#hard_bg' ) ).removeClass('category_button_unsel category_button ');
                angular.element( document.querySelector( '#easy_bg' ) ).addClass('category_button_unsel');
                angular.element( document.querySelector( '#hard_bg' ) ).addClass('category_button');
                break;
        }

    }


    $scope.openGameScreen= function(){
        $state.go('preGame');
    }

})

.controller('ResultCtrl', function($scope,$rootScope,$state,$cordovaGoogleAnalytics,$ionicPlatform) {

    $scope.$on('$ionicView.beforeEnter', function(){
        console.log("root scope is "+$rootScope.gameScore);
        var game_elem = angular.element( document.querySelector( '#game_point' ) );
        game_elem.html("");
        game_elem.html($rootScope.gameScore);
        window.plugins.insomnia.allowSleepAgain();
        $cordovaGoogleAnalytics.startTrackerWithId('UA-75583108-1');
        $cordovaGoogleAnalytics.trackEvent("userScore","User final score",$rootScope.gameMode,$rootScope.gameScore);
    });




    $ionicPlatform.ready(function() {
        console.log("everything is ready ");
        $cordovaGoogleAnalytics.startTrackerWithId('UA-75583108-1');
        $cordovaGoogleAnalytics.trackView('Result screen');
        console.log("cordova analytics");
    });




    $scope.playAgain= function(){
        $state.go('gameScreen');
        window.plugins.nativepagetransitions.slide(
            {"direction":"left"},
            function (msg) {console.log("success: " + msg)}, // called when the animation has finished
            function (msg) {alert("error: " + msg)} // called in case you pass in weird values
        );
    }

    $scope.categoryScreen = function(){
        $rootScope.gameScore=0;
        $state.go('selectCategory');
        window.plugins.nativepagetransitions.slide(
            {"direction":"left"},
            function (msg) {console.log("success: " + msg)}, // called when the animation has finished
            function (msg) {alert("error: " + msg)} // called in case you pass in weird values
        );

    }

})

.controller('GameCtrl', function($ionicPlatform,$scope,$rootScope,$cordovaDeviceMotion,$cordovaVibration,$state,$cordovaGoogleAnalytics) {

    var watch;
    var counter;
    $scope.$on('$ionicView.beforeEnter', function(){

        console.log("hi i am here guys  CP!");
   //     screen.lockOrientation('landscape-primary');
        initGame();
    });



    $ionicPlatform.ready(function() {
        console.log("everything is ready ");
        $cordovaGoogleAnalytics.startTrackerWithId('UA-75583108-1');
        $cordovaGoogleAnalytics.trackView('Gameplay screen');
        console.log("cordova analytics");
    });


    $scope.finishGame = function (){
        watch.clearWatch();
        clearInterval(counter);
        $rootScope.gameScore=0;
        $state.go('selectCategory');
        window.plugins.nativepagetransitions.slide(
            {"direction":"left"},
            function (msg) {console.log("success: " + msg)}, // called when the animation has finished
            function (msg) {alert("error: " + msg)} // called in case you pass in weird values
        );

    }


    function initGame(){
        $rootScope.gameScore=0;
        $scope.gameArray=$rootScope.gameArray;
        console.log($scope.gameArray);
        $scope.countdownTime=$rootScope.gameMode;
        $scope.currentWord="";
        $scope.canChangeWord=true;
        startGame();
        startAcceleration();
        window.plugins.insomnia.keepAwake(); //so that the game does not sleep.
    }

    $ionicPlatform.registerBackButtonAction(function () {
            watch.clearWatch();
            clearInterval(counter);
            $rootScope.gameScore=0;
            $state.go('selectCategory');
        window.plugins.nativepagetransitions.slide(
            {"direction":"left"},
            function (msg) {console.log("success: " + msg)}, // called when the animation has finished
            function (msg) {alert("error: " + msg)} // called in case you pass in weird values
        );
    }, 100);


    function startAcceleration(){
        console.log($cordovaDeviceMotion);
        //$scope.backgroundColorArray = ["yellow_bg_color", "purple_bg_color", "pink_bg_color","orange_bg_color"];
        $scope.backgroundColorArray = ["#FBC02D", "#9C27B0", "#FF4081","#FF5252"];
        $scope.textColorArray  =  ["yellow_game_screen_text", "purple_game_screen_text", "pink_game_screen_text","orange_game_screen_text"];
        $scope.selectStyle=0;
        var options = { frequency: 50 };
        watch = $cordovaDeviceMotion.watchAcceleration(options);
        watch.then(
            null,
            function(error) {
                console.log("error");
            },
            function(result) {
                var Z = result.z;

                if(Z >=9 &&  Z<11){
                   if($scope.canChangeWord) {
                       $scope.canChangeWord=false;
                       if($rootScope.enableVibration){
                           $cordovaVibration.vibrate(100);
                       }
                       changeColor();
                       changeWord();
                       setTimeout(function(){ $scope.canChangeWord=true; }, 600);
                       $cordovaGoogleAnalytics.trackEvent("userAnswer","wrong",$rootScope.gameMode,$rootScope.gameScore);
                   }
                }
                if(Z >=-11 && Z <-9){
                    if($scope.canChangeWord) {
                        $rootScope.gameScore = $rootScope.gameScore + 1;
                        $scope.canChangeWord=false;
                        if($rootScope.enableVibration) {
                            $cordovaVibration.vibrate(100);
                        }
                        changeColor();
                        changeWord();
                        setTimeout(function(){ $scope.canChangeWord=true; }, 600);
                        $cordovaGoogleAnalytics.trackEvent("userAnswer","correct",$rootScope.gameMode,$rootScope.gameScore);
                    }
                }

            });
    }


    function removePreviousClasses(){

        angular.element(document.querySelector('#game_bg')).removeClass('yellow_bg_color');
        angular.element(document.querySelector('#game_word')).removeClass('yellow_game_screen_text');
        angular.element(document.querySelector('#game_bg')).removeClass('purple_bg_color');
        angular.element(document.querySelector('#game_word')).removeClass('purple_game_screen_text');
        angular.element(document.querySelector('#game_bg')).removeClass('pink_bg_color');
        angular.element(document.querySelector('#game_word')).removeClass('pink_game_screen_text');
        angular.element(document.querySelector('#game_bg')).removeClass('orange_bg_color');
        angular.element(document.querySelector('#game_word')).removeClass('orange_game_screen_text');
    }

    function changeColor(){
        var rand_index=getRandomInt(0,3);
        if(rand_index == $scope.selectStyle){
            changeColor();
        }else {
            $scope.selectStyle=rand_index;
            removePreviousClasses();
            $rootScope.viewColor = $scope.backgroundColorArray[rand_index];
            angular.element(document.querySelector('#game_word')).addClass($scope.textColorArray[rand_index]);
        }
    }


    function getRandomInt(min, max) {
        return Math.floor(Math.random() * (max - min + 1)) + min;
    }


    function startGame(){
        $scope.currentWord=getNewWordFromArray();
        var myEl1 = angular.element( document.querySelector( '#game_word' ) );
        myEl1.html($scope.currentWord);
        startCountDownTimer();
    }



    function startCountDownTimer(){
        var sTime = new Date().getTime();
        var countDown = $scope.countdownTime;
        counter = setInterval(UpdateTime, 500);
        UpdateTime();

        function UpdateTime() {
            var cTime = new Date().getTime();
            var diff = cTime - sTime;
            var seconds = countDown - Math.floor(diff / 1000);
            if (seconds >= 0) {
                var minutes = Math.floor(seconds / 60);
                seconds -= minutes * 60;
                var min_text=minutes < 10 ? "0" + minutes : minutes;
                var sec_text=seconds < 10 ? "0" + seconds : seconds;
                var myEl1 = angular.element( document.querySelector( '#min' ) );
                var myEl2 = angular.element( document.querySelector( '#sec' ) );
                myEl1.html(min_text);
                myEl2.html(sec_text);
            } else {
                clearInterval(counter);
                gameOver();
            }
        }
    }


    function gameOver(){
        watch.clearWatch();
        clearInterval(counter);
        $state.go('resultScreen');
        window.plugins.nativepagetransitions.slide(
            {"direction":"right"},
            function (msg) {console.log("success: " + msg)}, // called when the animation has finished
            function (msg) {alert("error: " + msg)} // called in case you pass in weird values
        );
    }



    function changeWord(){
        $scope.currentWord=  getNewWordFromArray();
        var myEl1 = angular.element( document.querySelector( '#game_word' ) );
        myEl1.html($scope.currentWord);

    }


    function getNewWordFromArray() {
        /*
            1. get random word from array.
            2. remove the word from the array so it is not repeated.
         */
        console.log($scope.gameArray.length);
        if($scope.gameArray.length>0) {
            var rand_index = Math.abs(Math.floor(Math.random() * $scope.gameArray.length));
            var obj_name = $scope.gameArray[rand_index];
            if (rand_index > -1) {
                $scope.gameArray.splice(rand_index, 1);
            }
            return obj_name;
        }else{
            gameOver();
        }
    }
})